/* eslint-disable */
import {
  CallOptions,
  ChannelCredentials,
  Client,
  ClientDuplexStream,
  ClientOptions,
  ClientUnaryCall,
  handleBidiStreamingCall,
  handleUnaryCall,
  makeGenericClientConstructor,
  Metadata,
  ServiceError,
  UntypedServiceImplementation,
} from "@grpc/grpc-js";
import Long from "long";
import _m0 from "protobufjs/minimal";
import { Any } from "../../../google/protobuf/any";
import { Error } from "./errors";

export const protobufPackage = "trisa.api.v1beta1";

/**
 * Encrypted transaction envelope that is the outer layer of the TRISA information
 * exchange protocol and facilitates the secure storage of KYC data in a transaction.
 * The envelope specifies a unique id to reference the transaction out-of-band (e.g in
 * the blockchain layer) and provides the necessary information so that only the
 * originator and the beneficiary can decrypt the trnasaction data.
 */
export interface SecureEnvelope {
  /**
   * The transaction identifier generated by the sender. Any message concerning the
   * same blockhain transaction requires the same envelope ID on both sending and
   * responding RPCs.
   */
  id: string;
  /**
   * Encrypted payload that contains the IVMS 101 IdentityPayload for compliance and
   * a generic transaction payload that is used to identify the transaction on the
   * blockchain or perform flow control messages in TRISA itself. This payload should
   * be encrypted using the encryption algorithm and key defined below.
   */
  payload: Buffer;
  /**
   * Encryption key used to encrypt the compliance payload, usually generated on a
   * per-envelope basis. To seal the envelope, this key should be encrypted with the
   * public key of the recipient. If this key is in the clear, the sealed flag should
   * be false.
   */
  encryptionKey: Buffer;
  /**
   * The encryption algorithm used to encrypt the compliance payload. This string
   * should provide enough information for the recipient to understand how to decrypt
   * the payload including algorithm, variants, block length, etc.
   */
  encryptionAlgorithm: string;
  /**
   * HMAC signature calculated from encrypted encrypted compliance payload using the
   * hmac algorithm and secret defined below. This signature provides non-repudiation
   * to regulators and counterparties that ensure the envelope has not been tampered
   * with after receipt, particularly when comparing two envelopes.
   */
  hmac: Buffer;
  /**
   * The HMAC secret used to calculate the HMAC signature. To seal the envelope, this
   * secret should be encrypted with the public key of the recipient. If this secret
   * is in the clear, the sealed flag should be false.
   */
  hmacSecret: Buffer;
  /**
   * The algorithm used to calculate the HMAC signature. This string should provide
   * enough information for the recipient to understand how to compute the HMAC
   * including algorithm, block length, hashing function, etc.
   */
  hmacAlgorithm: string;
  /**
   * Rejection/TRISA errors should be specified in the SecureEnvelope for correct
   * compliance processing and not returned as a gRPC error. E.g. if the counterparty
   * wishes to send a TRISA error, they should send an OK gRPC response with the error
   * in this field. Networking errors such as unavailable, mTLS failure, or timeouts
   * are handled separately from compliance-related errors.
   */
  error:
    | Error
    | undefined;
  /**
   * The RFC-3339 formatted timestamp at nanosecond resolution. Used to order
   * SecureEnvelopes related to the same transaction. While this timestamp is likely
   * the same as the sent_at timestamp in the compliance payload, it does not serve
   * the same purpose. The compliance payload timestamps are for non-repudiation,
   * whereas this timestamp is for envelope and communication management.
   */
  timestamp: string;
  /**
   * Metadata related to the public key cryptography that seal the envelope by
   * encrypting the encryption key and hmac secret such that only the recipient can
   * fully decrypt the envelope. If the envelope is sealed, it indicates that the
   * encryption key and hmac secret are encrypted with a public key, whose signature
   * can be used for the recipient to identify the key pair required for decryption.
   */
  sealed: boolean;
  publicKeySignature: string;
}

/**
 * Payload contains the compliance identity information that must be exchanged in a
 * secure fashion, transaction information for both counterparties to uniquely identify
 * the transaction on the chain, and timestamps that are used for regulatory
 * non-repudiation. This payload is serialized and encrypted to be sent in the
 * SecureEnvelope as well as digitally signed to ensure that the payload has not been
 * tampered with after transmission. The internal message types of the payload are
 * purposefully generic to allow flexibility with the data needs for different exchanges.
 */
export interface Payload {
  /**
   * Identity contains any valid identity structure. The expected format is the
   * IVMS101 IdentityPayload which contains the originator and beneficiary identities,
   * the originator and beneficiary VASP identities, as well as the transfer path of
   * any intermediate VASPs. The identity payload can be bidirectional (containing
   * both originator and beneficiary identities) or unidirectional - containing only
   * the identity of the sender. In the bidirectional case, the identity may be
   * purposefully partial to allow the recipient to fill in the details. In the
   * unidirectional case, the identities must be collated after.
   */
  identity:
    | Any
    | undefined;
  /**
   * Transaction contains network specific information about the exchange or transfer.
   * It can also contain transfer control messages such as Pending messages to
   * facilitate multi-message compliance exchanges. These messages must all be
   * digtially signed for auditing purposes.
   */
  transaction:
    | Any
    | undefined;
  /**
   * Timestamps that describe when the payload was originally sent and when it was
   * accepted or received by the counterparty. These timestamps must be in the payload
   * so that they are digitally signed for non-repudiation. Both timestamps should be
   * RFC-3339 formatted strings with timezone information.
   */
  sentAt: string;
  receivedAt: string;
}

/** TODO: specify the address confirmation protocol. */
export interface Address {
}

export interface AddressConfirmation {
}

/**
 * SigningKey provides metadata for decoding a PEM encoded PKIX public key for RSA
 * encryption and transaction signing. The SigningKey is a lightweight version of the
 * Certificate information stored in the Directory Service.
 */
export interface SigningKey {
  /** x.509 metadata information for ease of reference without parsing the key. */
  version: number;
  signature: Buffer;
  signatureAlgorithm: string;
  publicKeyAlgorithm: string;
  /** Validity information */
  notBefore: string;
  notAfter: string;
  revoked: boolean;
  /** The serialized public key to PKIX, ASN.1 DER form. */
  data: Buffer;
}

export interface HealthCheck {
  /** The number of failed health checks that proceeded the current check. */
  attempts: number;
  /** The timestamp of the last health check, successful or otherwise. */
  lastCheckedAt: string;
}

export interface ServiceState {
  /**
   * Current service status as defined by the recieving system. The system is obliged
   * to respond with the closest matching status in a best-effort fashion. Alerts will
   * be triggered on service status changes if the system does not respond and the
   * previous system state was not unknown.
   */
  status: ServiceState_Status;
  /** Suggest to the directory service when to check the health status again. */
  notBefore: string;
  notAfter: string;
}

export enum ServiceState_Status {
  UNKNOWN = 0,
  HEALTHY = 1,
  UNHEALTHY = 2,
  DANGER = 3,
  OFFLINE = 4,
  MAINTENANCE = 5,
  UNRECOGNIZED = -1,
}

export function serviceState_StatusFromJSON(object: any): ServiceState_Status {
  switch (object) {
    case 0:
    case "UNKNOWN":
      return ServiceState_Status.UNKNOWN;
    case 1:
    case "HEALTHY":
      return ServiceState_Status.HEALTHY;
    case 2:
    case "UNHEALTHY":
      return ServiceState_Status.UNHEALTHY;
    case 3:
    case "DANGER":
      return ServiceState_Status.DANGER;
    case 4:
    case "OFFLINE":
      return ServiceState_Status.OFFLINE;
    case 5:
    case "MAINTENANCE":
      return ServiceState_Status.MAINTENANCE;
    case -1:
    case "UNRECOGNIZED":
    default:
      return ServiceState_Status.UNRECOGNIZED;
  }
}

export function serviceState_StatusToJSON(object: ServiceState_Status): string {
  switch (object) {
    case ServiceState_Status.UNKNOWN:
      return "UNKNOWN";
    case ServiceState_Status.HEALTHY:
      return "HEALTHY";
    case ServiceState_Status.UNHEALTHY:
      return "UNHEALTHY";
    case ServiceState_Status.DANGER:
      return "DANGER";
    case ServiceState_Status.OFFLINE:
      return "OFFLINE";
    case ServiceState_Status.MAINTENANCE:
      return "MAINTENANCE";
    case ServiceState_Status.UNRECOGNIZED:
    default:
      return "UNRECOGNIZED";
  }
}

function createBaseSecureEnvelope(): SecureEnvelope {
  return {
    id: "",
    payload: Buffer.alloc(0),
    encryptionKey: Buffer.alloc(0),
    encryptionAlgorithm: "",
    hmac: Buffer.alloc(0),
    hmacSecret: Buffer.alloc(0),
    hmacAlgorithm: "",
    error: undefined,
    timestamp: "",
    sealed: false,
    publicKeySignature: "",
  };
}

export const SecureEnvelope = {
  encode(message: SecureEnvelope, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.id !== "") {
      writer.uint32(10).string(message.id);
    }
    if (message.payload.length !== 0) {
      writer.uint32(18).bytes(message.payload);
    }
    if (message.encryptionKey.length !== 0) {
      writer.uint32(26).bytes(message.encryptionKey);
    }
    if (message.encryptionAlgorithm !== "") {
      writer.uint32(34).string(message.encryptionAlgorithm);
    }
    if (message.hmac.length !== 0) {
      writer.uint32(42).bytes(message.hmac);
    }
    if (message.hmacSecret.length !== 0) {
      writer.uint32(50).bytes(message.hmacSecret);
    }
    if (message.hmacAlgorithm !== "") {
      writer.uint32(58).string(message.hmacAlgorithm);
    }
    if (message.error !== undefined) {
      Error.encode(message.error, writer.uint32(74).fork()).ldelim();
    }
    if (message.timestamp !== "") {
      writer.uint32(82).string(message.timestamp);
    }
    if (message.sealed === true) {
      writer.uint32(88).bool(message.sealed);
    }
    if (message.publicKeySignature !== "") {
      writer.uint32(98).string(message.publicKeySignature);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): SecureEnvelope {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSecureEnvelope();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 10) {
            break;
          }

          message.id = reader.string();
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.payload = reader.bytes() as Buffer;
          continue;
        case 3:
          if (tag != 26) {
            break;
          }

          message.encryptionKey = reader.bytes() as Buffer;
          continue;
        case 4:
          if (tag != 34) {
            break;
          }

          message.encryptionAlgorithm = reader.string();
          continue;
        case 5:
          if (tag != 42) {
            break;
          }

          message.hmac = reader.bytes() as Buffer;
          continue;
        case 6:
          if (tag != 50) {
            break;
          }

          message.hmacSecret = reader.bytes() as Buffer;
          continue;
        case 7:
          if (tag != 58) {
            break;
          }

          message.hmacAlgorithm = reader.string();
          continue;
        case 9:
          if (tag != 74) {
            break;
          }

          message.error = Error.decode(reader, reader.uint32());
          continue;
        case 10:
          if (tag != 82) {
            break;
          }

          message.timestamp = reader.string();
          continue;
        case 11:
          if (tag != 88) {
            break;
          }

          message.sealed = reader.bool();
          continue;
        case 12:
          if (tag != 98) {
            break;
          }

          message.publicKeySignature = reader.string();
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): SecureEnvelope {
    return {
      id: isSet(object.id) ? String(object.id) : "",
      payload: isSet(object.payload) ? Buffer.from(bytesFromBase64(object.payload)) : Buffer.alloc(0),
      encryptionKey: isSet(object.encryptionKey) ? Buffer.from(bytesFromBase64(object.encryptionKey)) : Buffer.alloc(0),
      encryptionAlgorithm: isSet(object.encryptionAlgorithm) ? String(object.encryptionAlgorithm) : "",
      hmac: isSet(object.hmac) ? Buffer.from(bytesFromBase64(object.hmac)) : Buffer.alloc(0),
      hmacSecret: isSet(object.hmacSecret) ? Buffer.from(bytesFromBase64(object.hmacSecret)) : Buffer.alloc(0),
      hmacAlgorithm: isSet(object.hmacAlgorithm) ? String(object.hmacAlgorithm) : "",
      error: isSet(object.error) ? Error.fromJSON(object.error) : undefined,
      timestamp: isSet(object.timestamp) ? String(object.timestamp) : "",
      sealed: isSet(object.sealed) ? Boolean(object.sealed) : false,
      publicKeySignature: isSet(object.publicKeySignature) ? String(object.publicKeySignature) : "",
    };
  },

  toJSON(message: SecureEnvelope): unknown {
    const obj: any = {};
    message.id !== undefined && (obj.id = message.id);
    message.payload !== undefined &&
      (obj.payload = base64FromBytes(message.payload !== undefined ? message.payload : Buffer.alloc(0)));
    message.encryptionKey !== undefined &&
      (obj.encryptionKey = base64FromBytes(
        message.encryptionKey !== undefined ? message.encryptionKey : Buffer.alloc(0),
      ));
    message.encryptionAlgorithm !== undefined && (obj.encryptionAlgorithm = message.encryptionAlgorithm);
    message.hmac !== undefined &&
      (obj.hmac = base64FromBytes(message.hmac !== undefined ? message.hmac : Buffer.alloc(0)));
    message.hmacSecret !== undefined &&
      (obj.hmacSecret = base64FromBytes(message.hmacSecret !== undefined ? message.hmacSecret : Buffer.alloc(0)));
    message.hmacAlgorithm !== undefined && (obj.hmacAlgorithm = message.hmacAlgorithm);
    message.error !== undefined && (obj.error = message.error ? Error.toJSON(message.error) : undefined);
    message.timestamp !== undefined && (obj.timestamp = message.timestamp);
    message.sealed !== undefined && (obj.sealed = message.sealed);
    message.publicKeySignature !== undefined && (obj.publicKeySignature = message.publicKeySignature);
    return obj;
  },

  create<I extends Exact<DeepPartial<SecureEnvelope>, I>>(base?: I): SecureEnvelope {
    return SecureEnvelope.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<SecureEnvelope>, I>>(object: I): SecureEnvelope {
    const message = createBaseSecureEnvelope();
    message.id = object.id ?? "";
    message.payload = object.payload ?? Buffer.alloc(0);
    message.encryptionKey = object.encryptionKey ?? Buffer.alloc(0);
    message.encryptionAlgorithm = object.encryptionAlgorithm ?? "";
    message.hmac = object.hmac ?? Buffer.alloc(0);
    message.hmacSecret = object.hmacSecret ?? Buffer.alloc(0);
    message.hmacAlgorithm = object.hmacAlgorithm ?? "";
    message.error = (object.error !== undefined && object.error !== null) ? Error.fromPartial(object.error) : undefined;
    message.timestamp = object.timestamp ?? "";
    message.sealed = object.sealed ?? false;
    message.publicKeySignature = object.publicKeySignature ?? "";
    return message;
  },
};

function createBasePayload(): Payload {
  return { identity: undefined, transaction: undefined, sentAt: "", receivedAt: "" };
}

export const Payload = {
  encode(message: Payload, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.identity !== undefined) {
      Any.encode(message.identity, writer.uint32(10).fork()).ldelim();
    }
    if (message.transaction !== undefined) {
      Any.encode(message.transaction, writer.uint32(18).fork()).ldelim();
    }
    if (message.sentAt !== "") {
      writer.uint32(26).string(message.sentAt);
    }
    if (message.receivedAt !== "") {
      writer.uint32(34).string(message.receivedAt);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Payload {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBasePayload();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 10) {
            break;
          }

          message.identity = Any.decode(reader, reader.uint32());
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.transaction = Any.decode(reader, reader.uint32());
          continue;
        case 3:
          if (tag != 26) {
            break;
          }

          message.sentAt = reader.string();
          continue;
        case 4:
          if (tag != 34) {
            break;
          }

          message.receivedAt = reader.string();
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): Payload {
    return {
      identity: isSet(object.identity) ? Any.fromJSON(object.identity) : undefined,
      transaction: isSet(object.transaction) ? Any.fromJSON(object.transaction) : undefined,
      sentAt: isSet(object.sentAt) ? String(object.sentAt) : "",
      receivedAt: isSet(object.receivedAt) ? String(object.receivedAt) : "",
    };
  },

  toJSON(message: Payload): unknown {
    const obj: any = {};
    message.identity !== undefined && (obj.identity = message.identity ? Any.toJSON(message.identity) : undefined);
    message.transaction !== undefined &&
      (obj.transaction = message.transaction ? Any.toJSON(message.transaction) : undefined);
    message.sentAt !== undefined && (obj.sentAt = message.sentAt);
    message.receivedAt !== undefined && (obj.receivedAt = message.receivedAt);
    return obj;
  },

  create<I extends Exact<DeepPartial<Payload>, I>>(base?: I): Payload {
    return Payload.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<Payload>, I>>(object: I): Payload {
    const message = createBasePayload();
    message.identity = (object.identity !== undefined && object.identity !== null)
      ? Any.fromPartial(object.identity)
      : undefined;
    message.transaction = (object.transaction !== undefined && object.transaction !== null)
      ? Any.fromPartial(object.transaction)
      : undefined;
    message.sentAt = object.sentAt ?? "";
    message.receivedAt = object.receivedAt ?? "";
    return message;
  },
};

function createBaseAddress(): Address {
  return {};
}

export const Address = {
  encode(_: Address, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Address {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAddress();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(_: any): Address {
    return {};
  },

  toJSON(_: Address): unknown {
    const obj: any = {};
    return obj;
  },

  create<I extends Exact<DeepPartial<Address>, I>>(base?: I): Address {
    return Address.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<Address>, I>>(_: I): Address {
    const message = createBaseAddress();
    return message;
  },
};

function createBaseAddressConfirmation(): AddressConfirmation {
  return {};
}

export const AddressConfirmation = {
  encode(_: AddressConfirmation, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): AddressConfirmation {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseAddressConfirmation();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(_: any): AddressConfirmation {
    return {};
  },

  toJSON(_: AddressConfirmation): unknown {
    const obj: any = {};
    return obj;
  },

  create<I extends Exact<DeepPartial<AddressConfirmation>, I>>(base?: I): AddressConfirmation {
    return AddressConfirmation.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<AddressConfirmation>, I>>(_: I): AddressConfirmation {
    const message = createBaseAddressConfirmation();
    return message;
  },
};

function createBaseSigningKey(): SigningKey {
  return {
    version: 0,
    signature: Buffer.alloc(0),
    signatureAlgorithm: "",
    publicKeyAlgorithm: "",
    notBefore: "",
    notAfter: "",
    revoked: false,
    data: Buffer.alloc(0),
  };
}

export const SigningKey = {
  encode(message: SigningKey, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.version !== 0) {
      writer.uint32(8).int64(message.version);
    }
    if (message.signature.length !== 0) {
      writer.uint32(18).bytes(message.signature);
    }
    if (message.signatureAlgorithm !== "") {
      writer.uint32(26).string(message.signatureAlgorithm);
    }
    if (message.publicKeyAlgorithm !== "") {
      writer.uint32(34).string(message.publicKeyAlgorithm);
    }
    if (message.notBefore !== "") {
      writer.uint32(66).string(message.notBefore);
    }
    if (message.notAfter !== "") {
      writer.uint32(74).string(message.notAfter);
    }
    if (message.revoked === true) {
      writer.uint32(80).bool(message.revoked);
    }
    if (message.data.length !== 0) {
      writer.uint32(90).bytes(message.data);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): SigningKey {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSigningKey();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 8) {
            break;
          }

          message.version = longToNumber(reader.int64() as Long);
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.signature = reader.bytes() as Buffer;
          continue;
        case 3:
          if (tag != 26) {
            break;
          }

          message.signatureAlgorithm = reader.string();
          continue;
        case 4:
          if (tag != 34) {
            break;
          }

          message.publicKeyAlgorithm = reader.string();
          continue;
        case 8:
          if (tag != 66) {
            break;
          }

          message.notBefore = reader.string();
          continue;
        case 9:
          if (tag != 74) {
            break;
          }

          message.notAfter = reader.string();
          continue;
        case 10:
          if (tag != 80) {
            break;
          }

          message.revoked = reader.bool();
          continue;
        case 11:
          if (tag != 90) {
            break;
          }

          message.data = reader.bytes() as Buffer;
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): SigningKey {
    return {
      version: isSet(object.version) ? Number(object.version) : 0,
      signature: isSet(object.signature) ? Buffer.from(bytesFromBase64(object.signature)) : Buffer.alloc(0),
      signatureAlgorithm: isSet(object.signatureAlgorithm) ? String(object.signatureAlgorithm) : "",
      publicKeyAlgorithm: isSet(object.publicKeyAlgorithm) ? String(object.publicKeyAlgorithm) : "",
      notBefore: isSet(object.notBefore) ? String(object.notBefore) : "",
      notAfter: isSet(object.notAfter) ? String(object.notAfter) : "",
      revoked: isSet(object.revoked) ? Boolean(object.revoked) : false,
      data: isSet(object.data) ? Buffer.from(bytesFromBase64(object.data)) : Buffer.alloc(0),
    };
  },

  toJSON(message: SigningKey): unknown {
    const obj: any = {};
    message.version !== undefined && (obj.version = Math.round(message.version));
    message.signature !== undefined &&
      (obj.signature = base64FromBytes(message.signature !== undefined ? message.signature : Buffer.alloc(0)));
    message.signatureAlgorithm !== undefined && (obj.signatureAlgorithm = message.signatureAlgorithm);
    message.publicKeyAlgorithm !== undefined && (obj.publicKeyAlgorithm = message.publicKeyAlgorithm);
    message.notBefore !== undefined && (obj.notBefore = message.notBefore);
    message.notAfter !== undefined && (obj.notAfter = message.notAfter);
    message.revoked !== undefined && (obj.revoked = message.revoked);
    message.data !== undefined &&
      (obj.data = base64FromBytes(message.data !== undefined ? message.data : Buffer.alloc(0)));
    return obj;
  },

  create<I extends Exact<DeepPartial<SigningKey>, I>>(base?: I): SigningKey {
    return SigningKey.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<SigningKey>, I>>(object: I): SigningKey {
    const message = createBaseSigningKey();
    message.version = object.version ?? 0;
    message.signature = object.signature ?? Buffer.alloc(0);
    message.signatureAlgorithm = object.signatureAlgorithm ?? "";
    message.publicKeyAlgorithm = object.publicKeyAlgorithm ?? "";
    message.notBefore = object.notBefore ?? "";
    message.notAfter = object.notAfter ?? "";
    message.revoked = object.revoked ?? false;
    message.data = object.data ?? Buffer.alloc(0);
    return message;
  },
};

function createBaseHealthCheck(): HealthCheck {
  return { attempts: 0, lastCheckedAt: "" };
}

export const HealthCheck = {
  encode(message: HealthCheck, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.attempts !== 0) {
      writer.uint32(8).uint32(message.attempts);
    }
    if (message.lastCheckedAt !== "") {
      writer.uint32(18).string(message.lastCheckedAt);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): HealthCheck {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseHealthCheck();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 8) {
            break;
          }

          message.attempts = reader.uint32();
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.lastCheckedAt = reader.string();
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): HealthCheck {
    return {
      attempts: isSet(object.attempts) ? Number(object.attempts) : 0,
      lastCheckedAt: isSet(object.lastCheckedAt) ? String(object.lastCheckedAt) : "",
    };
  },

  toJSON(message: HealthCheck): unknown {
    const obj: any = {};
    message.attempts !== undefined && (obj.attempts = Math.round(message.attempts));
    message.lastCheckedAt !== undefined && (obj.lastCheckedAt = message.lastCheckedAt);
    return obj;
  },

  create<I extends Exact<DeepPartial<HealthCheck>, I>>(base?: I): HealthCheck {
    return HealthCheck.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<HealthCheck>, I>>(object: I): HealthCheck {
    const message = createBaseHealthCheck();
    message.attempts = object.attempts ?? 0;
    message.lastCheckedAt = object.lastCheckedAt ?? "";
    return message;
  },
};

function createBaseServiceState(): ServiceState {
  return { status: 0, notBefore: "", notAfter: "" };
}

export const ServiceState = {
  encode(message: ServiceState, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.status !== 0) {
      writer.uint32(8).int32(message.status);
    }
    if (message.notBefore !== "") {
      writer.uint32(18).string(message.notBefore);
    }
    if (message.notAfter !== "") {
      writer.uint32(26).string(message.notAfter);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): ServiceState {
    const reader = input instanceof _m0.Reader ? input : _m0.Reader.create(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseServiceState();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          if (tag != 8) {
            break;
          }

          message.status = reader.int32() as any;
          continue;
        case 2:
          if (tag != 18) {
            break;
          }

          message.notBefore = reader.string();
          continue;
        case 3:
          if (tag != 26) {
            break;
          }

          message.notAfter = reader.string();
          continue;
      }
      if ((tag & 7) == 4 || tag == 0) {
        break;
      }
      reader.skipType(tag & 7);
    }
    return message;
  },

  fromJSON(object: any): ServiceState {
    return {
      status: isSet(object.status) ? serviceState_StatusFromJSON(object.status) : 0,
      notBefore: isSet(object.notBefore) ? String(object.notBefore) : "",
      notAfter: isSet(object.notAfter) ? String(object.notAfter) : "",
    };
  },

  toJSON(message: ServiceState): unknown {
    const obj: any = {};
    message.status !== undefined && (obj.status = serviceState_StatusToJSON(message.status));
    message.notBefore !== undefined && (obj.notBefore = message.notBefore);
    message.notAfter !== undefined && (obj.notAfter = message.notAfter);
    return obj;
  },

  create<I extends Exact<DeepPartial<ServiceState>, I>>(base?: I): ServiceState {
    return ServiceState.fromPartial(base ?? {});
  },

  fromPartial<I extends Exact<DeepPartial<ServiceState>, I>>(object: I): ServiceState {
    const message = createBaseServiceState();
    message.status = object.status ?? 0;
    message.notBefore = object.notBefore ?? "";
    message.notAfter = object.notAfter ?? "";
    return message;
  },
};

/**
 * The TRISANetwork service defines the peer-to-peer interactions between VASPs that are
 * necessary to conduct compliance information exchanges. All TRISA members must
 * implement all services described by the TRISA protocol to ensure that exchanges are
 * conducted correctly and securely. The primary RPCs are Transfer and TransferStream
 * which allow VASPs to exchange compliance information before conducting a virtual
 * asset transaction. The other RPCs facilitate Transfers, allowing address
 * confirmations prior to a transfer and public key exchange so that transaction
 * envelopes can be encrypted and signed.
 */
export type TRISANetworkService = typeof TRISANetworkService;
export const TRISANetworkService = {
  /**
   * To conduct an information exchange prior to a virtual asset transaction, an
   * originating VASP will send an encrypted transaction envelope to the beneficiary
   * VASP containing a unique ID for the transaction, the encrypted transaction bundle,
   * and metadata associated with the transaction cipher. In response, the beneficiary
   * will validate the transaction request, then return the beneficiary's transaction
   * information using the same unique transaction ID. The TRISANetwork provides both
   * a unary RPC for simple, single transactions and a transaction stream for high
   * throughput transaction workloads.
   */
  transfer: {
    path: "/trisa.api.v1beta1.TRISANetwork/Transfer",
    requestStream: false,
    responseStream: false,
    requestSerialize: (value: SecureEnvelope) => Buffer.from(SecureEnvelope.encode(value).finish()),
    requestDeserialize: (value: Buffer) => SecureEnvelope.decode(value),
    responseSerialize: (value: SecureEnvelope) => Buffer.from(SecureEnvelope.encode(value).finish()),
    responseDeserialize: (value: Buffer) => SecureEnvelope.decode(value),
  },
  transferStream: {
    path: "/trisa.api.v1beta1.TRISANetwork/TransferStream",
    requestStream: true,
    responseStream: true,
    requestSerialize: (value: SecureEnvelope) => Buffer.from(SecureEnvelope.encode(value).finish()),
    requestDeserialize: (value: Buffer) => SecureEnvelope.decode(value),
    responseSerialize: (value: SecureEnvelope) => Buffer.from(SecureEnvelope.encode(value).finish()),
    responseDeserialize: (value: Buffer) => SecureEnvelope.decode(value),
  },
  /**
   * Address confirmation allows an originator VASP to establish that a beneficiary
   * VASP has control of a crypto wallet address, prior to sending transaction
   * information with sensitive PII data.
   */
  confirmAddress: {
    path: "/trisa.api.v1beta1.TRISANetwork/ConfirmAddress",
    requestStream: false,
    responseStream: false,
    requestSerialize: (value: Address) => Buffer.from(Address.encode(value).finish()),
    requestDeserialize: (value: Buffer) => Address.decode(value),
    responseSerialize: (value: AddressConfirmation) => Buffer.from(AddressConfirmation.encode(value).finish()),
    responseDeserialize: (value: Buffer) => AddressConfirmation.decode(value),
  },
  /**
   * The encrypted transaction envelope uses asymmetric (public/private) encryption to
   * exchange a symmetric key and signature for the transaction blob. To facilitate
   * transaction signatures, VASPs must be able to exchange public signing keys if
   * they have not already obtained them from the directory service.
   */
  keyExchange: {
    path: "/trisa.api.v1beta1.TRISANetwork/KeyExchange",
    requestStream: false,
    responseStream: false,
    requestSerialize: (value: SigningKey) => Buffer.from(SigningKey.encode(value).finish()),
    requestDeserialize: (value: Buffer) => SigningKey.decode(value),
    responseSerialize: (value: SigningKey) => Buffer.from(SigningKey.encode(value).finish()),
    responseDeserialize: (value: Buffer) => SigningKey.decode(value),
  },
} as const;

export interface TRISANetworkServer extends UntypedServiceImplementation {
  /**
   * To conduct an information exchange prior to a virtual asset transaction, an
   * originating VASP will send an encrypted transaction envelope to the beneficiary
   * VASP containing a unique ID for the transaction, the encrypted transaction bundle,
   * and metadata associated with the transaction cipher. In response, the beneficiary
   * will validate the transaction request, then return the beneficiary's transaction
   * information using the same unique transaction ID. The TRISANetwork provides both
   * a unary RPC for simple, single transactions and a transaction stream for high
   * throughput transaction workloads.
   */
  transfer: handleUnaryCall<SecureEnvelope, SecureEnvelope>;
  transferStream: handleBidiStreamingCall<SecureEnvelope, SecureEnvelope>;
  /**
   * Address confirmation allows an originator VASP to establish that a beneficiary
   * VASP has control of a crypto wallet address, prior to sending transaction
   * information with sensitive PII data.
   */
  confirmAddress: handleUnaryCall<Address, AddressConfirmation>;
  /**
   * The encrypted transaction envelope uses asymmetric (public/private) encryption to
   * exchange a symmetric key and signature for the transaction blob. To facilitate
   * transaction signatures, VASPs must be able to exchange public signing keys if
   * they have not already obtained them from the directory service.
   */
  keyExchange: handleUnaryCall<SigningKey, SigningKey>;
}

export interface TRISANetworkClient extends Client {
  /**
   * To conduct an information exchange prior to a virtual asset transaction, an
   * originating VASP will send an encrypted transaction envelope to the beneficiary
   * VASP containing a unique ID for the transaction, the encrypted transaction bundle,
   * and metadata associated with the transaction cipher. In response, the beneficiary
   * will validate the transaction request, then return the beneficiary's transaction
   * information using the same unique transaction ID. The TRISANetwork provides both
   * a unary RPC for simple, single transactions and a transaction stream for high
   * throughput transaction workloads.
   */
  transfer(
    request: SecureEnvelope,
    callback: (error: ServiceError | null, response: SecureEnvelope) => void,
  ): ClientUnaryCall;
  transfer(
    request: SecureEnvelope,
    metadata: Metadata,
    callback: (error: ServiceError | null, response: SecureEnvelope) => void,
  ): ClientUnaryCall;
  transfer(
    request: SecureEnvelope,
    metadata: Metadata,
    options: Partial<CallOptions>,
    callback: (error: ServiceError | null, response: SecureEnvelope) => void,
  ): ClientUnaryCall;
  transferStream(): ClientDuplexStream<SecureEnvelope, SecureEnvelope>;
  transferStream(options: Partial<CallOptions>): ClientDuplexStream<SecureEnvelope, SecureEnvelope>;
  transferStream(
    metadata: Metadata,
    options?: Partial<CallOptions>,
  ): ClientDuplexStream<SecureEnvelope, SecureEnvelope>;
  /**
   * Address confirmation allows an originator VASP to establish that a beneficiary
   * VASP has control of a crypto wallet address, prior to sending transaction
   * information with sensitive PII data.
   */
  confirmAddress(
    request: Address,
    callback: (error: ServiceError | null, response: AddressConfirmation) => void,
  ): ClientUnaryCall;
  confirmAddress(
    request: Address,
    metadata: Metadata,
    callback: (error: ServiceError | null, response: AddressConfirmation) => void,
  ): ClientUnaryCall;
  confirmAddress(
    request: Address,
    metadata: Metadata,
    options: Partial<CallOptions>,
    callback: (error: ServiceError | null, response: AddressConfirmation) => void,
  ): ClientUnaryCall;
  /**
   * The encrypted transaction envelope uses asymmetric (public/private) encryption to
   * exchange a symmetric key and signature for the transaction blob. To facilitate
   * transaction signatures, VASPs must be able to exchange public signing keys if
   * they have not already obtained them from the directory service.
   */
  keyExchange(
    request: SigningKey,
    callback: (error: ServiceError | null, response: SigningKey) => void,
  ): ClientUnaryCall;
  keyExchange(
    request: SigningKey,
    metadata: Metadata,
    callback: (error: ServiceError | null, response: SigningKey) => void,
  ): ClientUnaryCall;
  keyExchange(
    request: SigningKey,
    metadata: Metadata,
    options: Partial<CallOptions>,
    callback: (error: ServiceError | null, response: SigningKey) => void,
  ): ClientUnaryCall;
}

export const TRISANetworkClient = makeGenericClientConstructor(
  TRISANetworkService,
  "trisa.api.v1beta1.TRISANetwork",
) as unknown as {
  new (address: string, credentials: ChannelCredentials, options?: Partial<ClientOptions>): TRISANetworkClient;
  service: typeof TRISANetworkService;
};

/**
 * The TRISAHealth service is optional but highly recommended for VASP members to
 * implement. The Status endpoint allows the TRISA Directory Service to perform health
 * checks with VASP's TRISA Node and report the service conditions of the TRISA network.
 * Because a down TRISA node will prevent travel rule compliant virtual asset
 * transactions, the health service is intended to quickly identify network problems and
 * notify members as quickly as possible.
 *
 * NOTE: the TRISAHealth service must also be behind mTLS so that the health check
 * service can verify the identity certificates being used for the TRISANetwork service.
 */
export type TRISAHealthService = typeof TRISAHealthService;
export const TRISAHealthService = {
  status: {
    path: "/trisa.api.v1beta1.TRISAHealth/Status",
    requestStream: false,
    responseStream: false,
    requestSerialize: (value: HealthCheck) => Buffer.from(HealthCheck.encode(value).finish()),
    requestDeserialize: (value: Buffer) => HealthCheck.decode(value),
    responseSerialize: (value: ServiceState) => Buffer.from(ServiceState.encode(value).finish()),
    responseDeserialize: (value: Buffer) => ServiceState.decode(value),
  },
} as const;

export interface TRISAHealthServer extends UntypedServiceImplementation {
  status: handleUnaryCall<HealthCheck, ServiceState>;
}

export interface TRISAHealthClient extends Client {
  status(request: HealthCheck, callback: (error: ServiceError | null, response: ServiceState) => void): ClientUnaryCall;
  status(
    request: HealthCheck,
    metadata: Metadata,
    callback: (error: ServiceError | null, response: ServiceState) => void,
  ): ClientUnaryCall;
  status(
    request: HealthCheck,
    metadata: Metadata,
    options: Partial<CallOptions>,
    callback: (error: ServiceError | null, response: ServiceState) => void,
  ): ClientUnaryCall;
}

export const TRISAHealthClient = makeGenericClientConstructor(
  TRISAHealthService,
  "trisa.api.v1beta1.TRISAHealth",
) as unknown as {
  new (address: string, credentials: ChannelCredentials, options?: Partial<ClientOptions>): TRISAHealthClient;
  service: typeof TRISAHealthService;
};

declare var self: any | undefined;
declare var window: any | undefined;
declare var global: any | undefined;
var tsProtoGlobalThis: any = (() => {
  if (typeof globalThis !== "undefined") {
    return globalThis;
  }
  if (typeof self !== "undefined") {
    return self;
  }
  if (typeof window !== "undefined") {
    return window;
  }
  if (typeof global !== "undefined") {
    return global;
  }
  throw "Unable to locate global object";
})();

function bytesFromBase64(b64: string): Uint8Array {
  if (tsProtoGlobalThis.Buffer) {
    return Uint8Array.from(tsProtoGlobalThis.Buffer.from(b64, "base64"));
  } else {
    const bin = tsProtoGlobalThis.atob(b64);
    const arr = new Uint8Array(bin.length);
    for (let i = 0; i < bin.length; ++i) {
      arr[i] = bin.charCodeAt(i);
    }
    return arr;
  }
}

function base64FromBytes(arr: Uint8Array): string {
  if (tsProtoGlobalThis.Buffer) {
    return tsProtoGlobalThis.Buffer.from(arr).toString("base64");
  } else {
    const bin: string[] = [];
    arr.forEach((byte) => {
      bin.push(String.fromCharCode(byte));
    });
    return tsProtoGlobalThis.btoa(bin.join(""));
  }
}

type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;

export type DeepPartial<T> = T extends Builtin ? T
  : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>>
  : T extends {} ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P
  : P & { [K in keyof P]: Exact<P[K], I[K]> } & { [K in Exclude<keyof I, KeysOfUnion<P>>]: never };

function longToNumber(long: Long): number {
  if (long.gt(Number.MAX_SAFE_INTEGER)) {
    throw new tsProtoGlobalThis.Error("Value is larger than Number.MAX_SAFE_INTEGER");
  }
  return long.toNumber();
}

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
